<?
    header("Content-Type: text/plain");
    include_once ("../../conf/config.php");

    //critical errors
    if ($jffnms_satellite_uri=="none") die("Satellite not configured."); //we are not configured to be a satellite
    
    unsatellize_headers ($HTTP_RAW_POST_DATA, $capabilities, &$sat_id, &$class, &$method, &$params, &$session);
    
    if (!$method) die("Method not Specified."); 
    if (!$sat_id) die("Destination Satellite not Specified."); 
    $time_total = time_usec();

    //session stuff
    if (isset($session)) { //session to be used 
	$response = array();

	if ($session=="get") {
	    $session = uniqid(""); //start new session 
	    $response["session"]=$session; //only send session if it was the first request
	}

	ini_set('session.use_cookies', 0);
	session_id($session);
	session_cache_limiter('none');
	@session_start();
	
	if (!session_is_registered("my_sat_id")) { // session not registered
	    session_register("my_sat_id");
	    session_register("satellite");
	    session_register("session_vars"); //to store temp buffers for backends in poller or other things
	    session_register("satellite_destination"); //final elected destination for this connection
	    session_register("capabilities"); //requesting satellite capabilites
	    session_register("jffnms"); //to store jffnms object records
	}
    }

    if (!$satellite) 	$satellite = $jffnms->get("satellites");
    if (!$my_sat_id)	$my_sat_id = $satellite->get_id($jffnms_satellite_uri);
    if (!$session_vars)	$session_vars = array();

    if (!$class) $class = "satellite"; //default class
    if ($params) $params = unsatellize($params,$capabilities);

    $time_mode = time_usec(); //profile execution time

    $decide = $satellite->decide_mode ($my_sat_id,$sat_id,$from_sat_id); //decide execution mode (relay,direct,error)

    //if ($my_sat_id==4) { debug ($decide); die(); }

    if ($decide[mode]=="error") $response=$decide[error];

    if (($decide[mode]=="direct") && ($method!="none")) //try to call the method
	$response = $satellite->callback($method,$params,$class,$response);
    	
    if ($decide[mode]=="relay") { //relay message
	if ($ttl=="") $ttl = 10;
	
	if ( $ttl > 0 ) { //if TimeToLive > 0 means we can relay
	    $satellite_destinations = $decide[destinations];

	    if (!is_array($satellite_destination)) 
		$satellite_destination = $satellite->elect_one($satellite_destinations,$my_sat_id,$sat_id);
	
	    if (is_array($satellite_destination)) {
		foreach ($satellite_destination as $parent_sat_id=>$satellite_parent) {
		    $comment = "$my_sat_id-relay";

		    $message=Array(
			sat_id=>$sat_id,
			session=>$satellite_parent[session],
		        ttl=>--$ttl, //decrease TTL to send it
			"class"=>$class,
			method=>$method,
			params=>$params,
		    );	

		    if ($session_destroy) $message["session_destroy"]=$session_destroy; //relay the destroy message

		    $result = $satellite->query ($satellite_parent[url],$message,$comment,0); //FIXME change to GUI or general
		}
	    } else 
		$response[error][$my_sat_id][]="Source IP ".$_SERVER[REMOTE_ADDR]." Relay not allowed.";

	    if (is_array($result)) {
		unset ($result[session]); //dont mix session information
		$response = array_merge($result,$response);
	    } else
		$response = $result;
	} else //TTL
	    $response[error][$my_sat_id][]="TTL Excedded";
//	    $response[error]="TTL Excedded";
    } //if relay
    
    $time_mode = time_usec_diff($time_mode);
    	
    if ($session_destroy==1) { //destroy session data (frees memory)
	$aux = $my_sat_id; //save my_sat_id
	$aux1 = $capabilities; //save capabilties
    	$response["session_destroy"]=$result[session_destroy]; //pass data
	session_unset();
	
    	$response["session_destroy"][$aux]=(bool)session_destroy();
	$capabilities = $aux1;
    }

    if (is_array($response)) {
	$response[traceroute][]=Array(
			    my_sat_id=>$my_sat_id,
			    mode=>$decide[mode],
			    to_sat_id=>$sat_id,
			    dest=>$satellite_destination
			    );
	$response[times][$decide[mode]][$my_sat_id]=$time_mode;
	$response[times][real_total][$my_sat_id]=time_usec_diff($time_total);
	$response[times][step_total][$my_sat_id]=$response[times][real_total][$my_sat_id]-$response[times][real_total][$parent_sat_id];

        unset ($response[traceroute]); //dont send traceroute data
	unset ($response[times]); //dont send profiling data
    }

    echo satellize($response,$capabilities);
?>
